diff --git a/game/client/src/main/java/net/minecraft/client/Minecraft.java b/game/client/src/main/java/net/minecraft/client/Minecraft.java
index a12f7f9d2..a0b3b198c 100644
--- a/game/client/src/main/java/net/minecraft/client/Minecraft.java
+++ b/game/client/src/main/java/net/minecraft/client/Minecraft.java
@@ -1916,23 +1915,23 @@ public class Minecraft
         }
 
         // Zoom
-        if (this.gameSettings.keyZoom.isPressEvent(currentInputDevice)) {
+        if (GameSettings.KEY_ZOOM.isPressEvent(currentInputDevice)) {
             Mouse.getDWheel(); // This resets the mouse delta before its checked by zoom, fixes a bug please don't remove
             this.worldRenderer.zooming = true;
             return true;
         }
-        if (this.gameSettings.keyZoom.isReleaseEvent(currentInputDevice)) {
+        if (GameSettings.KEY_ZOOM.isReleaseEvent(currentInputDevice)) {
             this.worldRenderer.zooming = false;
             return true;
         }
 
         // Open Achievements
-        if (this.gameSettings.keyOpenAchievements.isPressEvent(currentInputDevice)) {
+        if (GameSettings.KEY_OPEN_ACHIEVEMENTS.isPressEvent(currentInputDevice)) {
             displayScreen(new ScreenAchievements(null, this.statsCounter));
         }
 
         // Open Statistics
-        if (this.gameSettings.keyOpenStatistics.isPressEvent(currentInputDevice)) {
+        if (GameSettings.KEY_OPEN_STATISTICS.isPressEvent(currentInputDevice)) {
             displayScreen(new ScreenStats(null, this.statsCounter));
         }
 
@@ -1983,7 +1982,7 @@ public class Minecraft
                 displayScreen(getInventoryScreen());
             }
             if (controller.buttonBack.pressedThisFrame()) {
-                this.gameSettings.showPlayerList.value = !this.gameSettings.showPlayerList.value;
+                GameSettings.SHOW_PLAYER_LIST.value = !GameSettings.SHOW_PLAYER_LIST.value;
             }
             if (controller.buttonStart.pressedThisFrame()) {
                 displayScreen(new ScreenPause());
@@ -2012,8 +2011,8 @@ public class Minecraft
                 this.thePlayer.inventory.changeCurrentSlot(-1);
             }
             if (controller.joyLeft.getButton().pressedThisFrame()) {
-                this.gameSettings.thirdPersonView.value++;
-                this.gameSettings.thirdPersonView.value %= 3;
+                GameSettings.THIRD_PERSON_VIEW.value++;
+                GameSettings.THIRD_PERSON_VIEW.value %= 3;
             }
             if (this.controllerInput.digitalPad.right.pressedThisFrame()) {
                 this.thePlayer.displayGuidebookScreen();
@@ -2030,9 +2029,9 @@ public class Minecraft
     private void forceReload() {
         long start = System.nanoTime();
         LOGGER.info("FORCING RELOAD!");
-        I18n.getInstance().reload(this.gameSettings.language.value);
+        I18n.getInstance().reload(GameSettings.LANGUAGE.value);
         this.sndManager = new SoundEngine();
-        this.sndManager.init(this.gameSettings);
+        this.sndManager.init();
         this.texturePackList.refresh();
         this.renderer.reload();
         Shaders.reload();
@@ -2061,10 +2060,11 @@ public class Minecraft
             worldConfiguration.getFinalWorldName(),
             worldConfiguration.getFinalNumericSeed(),
             Dimension.OVERWORLD,
-            null
+            null, worldConfiguration.getStartingBiome()
         );
         world.getLevelData().setCheatsEnabled(worldConfiguration.getCheatsEnabled());
         world.getLevelData().getGameRules().setValues(worldConfiguration.getGameRuleCollection());
+        world.getSpawnerConfig().set(worldConfiguration.getSpawnerConfig());
 
         this.statsCounter.add(StatList.createWorldStat, 1);
         this.statsCounter.add(StatList.startGameStat, 1);
@@ -2103,7 +2103,7 @@ public class Minecraft
                 dimension = Dimension.getDimensionList().get(tag.getInteger("Dimension"));
             }
 
-            WorldClient world = new WorldClient(saveHandler, null, 0L, dimension, null);
+            WorldClient world = new WorldClient(saveHandler, null, 0L, dimension, null, null);
             this.statsCounter.add(StatList.loadWorldStat, 1);
             this.statsCounter.add(StatList.startGameStat, 1);
             changeWorld(world, i18n.translateKey("gui.loading.label.loading"));
@@ -2165,7 +2165,7 @@ public class Minecraft
 
     public void changeWorld(WorldClient world, String loadingTitle, @Nullable Player player) {
         this.mainMenuBackground.deleteTextures();
-        this.gameSettings.showCollisionBoxes.value = false;
+        GameSettings.SHOW_COLLISION_BOXES.value = false;
 
         this.fullbright = false;
         this.statsCounter.fetchStats();
@@ -2620,15 +2620,15 @@ public class Minecraft
     }
 
     public boolean isAmbientOcclusionEnabled() {
-        return this.gameSettings.ambientOcclusion.value;
+        return GameSettings.AMBIENT_OCCLUSION.value;
     }
 
     public boolean isTreeShadingEnabled() {
-        return this.gameSettings.treeShadows.value;
+        return GameSettings.TREE_SHADOWS.value;
     }
 
     public boolean isDebugInfoEnabled() {
-        return this.gameSettings.showDebugScreen.value;
+        return GameSettings.SHOW_DEBUG_SCREEN.value;
     }
 
     @Override
@@ -2641,12 +2641,12 @@ public class Minecraft
     }
 
     public float getOutlineWidth() {
-        return INSTANCE.gameSettings.blockOutlineWidth.value;
+        return GameSettings.BLOCK_OUTLINE_WIDTH.value;
     }
 
     public int getAutosaveTimer() {
 
-        return (int) (INSTANCE.gameSettings.autosaveTimer.value * 24) * 5;
+        return (int) (GameSettings.AUTOSAVE_TIMER.value * 24) * 5;
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/discord/RichPresenceHandlerThread.java b/game/client/src/main/java/net/minecraft/client/discord/RichPresenceHandlerThread.java
index 6076e74e4..03eff517c 100644
--- a/game/client/src/main/java/net/minecraft/client/discord/RichPresenceHandlerThread.java
+++ b/game/client/src/main/java/net/minecraft/client/discord/RichPresenceHandlerThread.java
@@ -14,6 +14,7 @@ import de.jcm.discordgamesdk.activity.Activity;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.entity.player.PlayerLocalMultiplayer;
 import net.minecraft.client.gui.ScreenPause;
+import net.minecraft.client.option.GameSettings;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.biome.Biome;
 import net.minecraft.core.world.biome.Biomes;
@@ -99,7 +100,7 @@ public class RichPresenceHandlerThread extends Thread {
         // Initialize the Core
         Core.init(discordLibrary);
 
-        startTime = Instant.now();
+        this.startTime = Instant.now();
 
         // Create the Activity
         updateActivity();
@@ -107,12 +108,12 @@ public class RichPresenceHandlerThread extends Thread {
         int counter = 0;
         // Run callbacks forever
         while (true) {
-            if (core != null) {
-                if (!hasRegistered) {
-                    core.activityManager().registerCommand("e");
-                    hasRegistered = true;
+            if (this.core != null) {
+                if (!this.hasRegistered) {
+                    this.core.activityManager().registerCommand("e");
+                    this.hasRegistered = true;
                 }
-                core.runCallbacks();
+                this.core.runCallbacks();
             }
             try {
                 // Sleep a bit to save CPU
@@ -129,40 +130,40 @@ public class RichPresenceHandlerThread extends Thread {
     }
 
     private void updateActivity() {
-        if (!minecraft.gameSettings.discordRichPresence.value) {
-            if (core != null) {
+        if (!GameSettings.DISCORD_RICH_PRESENCE.value) {
+            if (this.core != null) {
                 destroyCore();
             }
         } else {
-            if (core == null) {
+            if (this.core == null) {
                 createCore();
             }
         }
 
-        if (core == null) return;
+        if (this.core == null) return;
 
         Activity activity = new Activity();
         activity.assets().setLargeImage("bta-logo");
-        activity.timestamps().setStart(startTime);
+        activity.timestamps().setStart(this.startTime);
 
-        if (minecraft.currentWorld == null) {
+        if (this.minecraft.currentWorld == null) {
             activity.setState("In the main menu");
-        } else if (minecraft.thePlayer != null) {
-            if (minecraft.thePlayer instanceof PlayerLocalMultiplayer) {
+        } else if (this.minecraft.thePlayer != null) {
+            if (this.minecraft.thePlayer instanceof PlayerLocalMultiplayer) {
                 activity.setDetails("Multiplayer");
-                int playerCount = ((PlayerLocalMultiplayer) minecraft.thePlayer).sendQueue.players.size();
+                int playerCount = ((PlayerLocalMultiplayer) this.minecraft.thePlayer).sendQueue.players.size();
                 activity.party().size().setCurrentSize(playerCount);
                 activity.party().size().setMaxSize(100);
             } else {
-                if (minecraft.currentScreen instanceof ScreenPause) {
+                if (this.minecraft.currentScreen instanceof ScreenPause) {
                     activity.setDetails("Singleplayer (paused)");
                 } else {
                     activity.setDetails("Singleplayer");
                 }
             }
-            Dimension activeDimension = Dimension.getDimensionList().get(minecraft.thePlayer.dimension);
-            Biome biome = minecraft.currentWorld.getBlockBiome((int) minecraft.thePlayer.x, (int) minecraft.thePlayer.y, (int) minecraft.thePlayer.z);
-            Weather weather = minecraft.currentWorld.getCurrentWeather();
+            Dimension activeDimension = Dimension.getDimensionList().get(this.minecraft.thePlayer.dimension);
+            Biome biome = this.minecraft.currentWorld.getBlockBiome((int) this.minecraft.thePlayer.x, (int) this.minecraft.thePlayer.y, (int) this.minecraft.thePlayer.z);
+            Weather weather = this.minecraft.currentWorld.getCurrentWeather();
 
             boolean displayDimension = activeDimension != null && dimensionNamesMap.containsKey(activeDimension);
             boolean displayBiome = biome != null && biomeNamesMap.containsKey(biome);
@@ -187,7 +188,7 @@ public class RichPresenceHandlerThread extends Thread {
             activity.setState(stateString.toString());
 
         }
-        core.activityManager().updateActivity(activity);
+        this.core.activityManager().updateActivity(activity);
     }
 
     private void createCore() {
@@ -196,15 +197,15 @@ public class RichPresenceHandlerThread extends Thread {
             params.setClientID(clientId);
             params.setFlags(CreateParams.Flags.NO_REQUIRE_DISCORD);
             // Create the Core
-            core = new Core(params);
+            this.core = new Core(params);
         } catch (GameSDKException sdkException) {
             // Exception normally occurs only when discord is not opened on the client
-            core = null;
+            this.core = null;
         }
     }
 
     private void destroyCore() {
-        core.close();
-        core = null;
+        this.core.close();
+        this.core = null;
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/entity/ClientSkinVariantList.java b/game/client/src/main/java/net/minecraft/client/entity/ClientSkinVariantList.java
index a3720b658..04e024314 100644
--- a/game/client/src/main/java/net/minecraft/client/entity/ClientSkinVariantList.java
+++ b/game/client/src/main/java/net/minecraft/client/entity/ClientSkinVariantList.java
@@ -18,6 +18,7 @@ import com.mojang.logging.LogUtils;
 import it.unimi.dsi.fastutil.objects.Object2IntMap;
 import it.unimi.dsi.fastutil.objects.Object2IntOpenHashMap;
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.option.GameSettings;
 import net.minecraft.core.entity.SkinVariantList;
 import net.minecraft.core.util.helper.MathHelper;
 import org.jetbrains.annotations.NotNull;
@@ -52,7 +53,7 @@ public class ClientSkinVariantList extends SkinVariantList {
 
 	protected @Nullable EntityVariants getEntityVariants(@Nullable final String variantJsonPath) {
 		try {
-			if (!Minecraft.getMinecraft().gameSettings.mobVariants.value) return null;
+			if (!GameSettings.MOB_VARIANTS.value) return null;
 			if (variantJsonPath == null) return null;
 			if (this.variantProcessorMap.containsKey(variantJsonPath)) {
 				return this.variantProcessorMap.get(variantJsonPath);
diff --git a/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java
index edfbae4ec..1a03d81b3 100644
--- a/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java
+++ b/game/client/src/main/java/net/minecraft/client/entity/player/PlayerLocal.java
@@ -5,6 +5,8 @@ import com.mojang.logging.LogUtils;
 import com.mojang.nbt.tags.CompoundTag;
 
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.option.GameSettings;
+import net.minecraft.client.option.enums.ParticlesQuality;
 import net.minecraft.client.render.particle.ParticlePickupAnimation;
 import net.minecraft.client.gui.container.*;
 import net.minecraft.client.gui.ScreenLabelEditor;
@@ -62,14 +64,16 @@ public class PlayerLocal extends Player {
         this.username = session.username;
         this.uuid = session.uuid;
 
-        this.playerConfig.setLeftHand(minecraft.gameSettings.playerLeftHanded.value);
-        this.playerConfig.setCape(minecraft.gameSettings.playerCape.value);
-        this.playerConfig.setHat(minecraft.gameSettings.playerHat.value);
-        this.playerConfig.setJacket(minecraft.gameSettings.playerJacket.value);
-        this.playerConfig.setSleeveLeft(minecraft.gameSettings.playerSleeveLeft.value);
-        this.playerConfig.setSleeveRight(minecraft.gameSettings.playerSleeveRight.value);
-        this.playerConfig.setPantLeft(minecraft.gameSettings.playerPantLeft.value);
-        this.playerConfig.setPantRight(minecraft.gameSettings.playerPantRight.value);
+        this.playerConfig.setLeftHand(GameSettings.PLAYER_LEFT_HANDED.value);
+        this.playerConfig.setCape(GameSettings.PLAYER_CAPE.value);
+        this.playerConfig.setHat(GameSettings.PLAYER_HAT.value);
+        this.playerConfig.setJacket(GameSettings.PLAYER_JACKET.value);
+        this.playerConfig.setSleeveLeft(GameSettings.PLAYER_SLEEVE_LEFT.value);
+        this.playerConfig.setSleeveRight(GameSettings.PLAYER_SLEEVE_RIGHT.value);
+        this.playerConfig.setPantLeft(GameSettings.PLAYER_PANT_LEFT.value);
+        this.playerConfig.setPantRight(GameSettings.PLAYER_PANT_RIGHT.value);
+        this.playerConfig.setDevModelEnabled(GameSettings.PLAYER_DEV_MODEL.value);
+        this.playerConfig.setHurtSound(GameSettings.PLAYER_HURT_SOUND.value);
 
         new GetSkinUrlThread(this);
         LOGGER.info("logged in with session name: {}", this.username);
@@ -192,7 +196,7 @@ public class PlayerLocal extends Player {
                 this.sprintTimer = 0;
             }
         }
-        if (this.onGround && canSprint && this.mc.gameSettings.keySprint.isPressed()) {
+        if (this.onGround && canSprint && GameSettings.KEY_SPRINT.isPressed()) {
             setSprinting(true);
         }
         if (isSprinting() && (this.input.moveForward < f || this.horizontalCollision || !canSprint)) {
@@ -311,6 +315,7 @@ public class PlayerLocal extends Player {
     @Override
     public void onItemPickup(Entity entity, ItemStack item) {
         addStat(item.getItem().getStat(StatList.STAT_PICKED_UP), 1);
+        if (GameSettings.PARTICLES_QUALITY.value == ParticlesQuality.NONE) return;
         this.mc.particleEngine.add(new ParticlePickupAnimation(this.mc.currentWorld, entity, this, -0.5F));
     }
 
@@ -379,7 +384,7 @@ public class PlayerLocal extends Player {
     }
 
     @Override
-    public void addStat(Stat stat, int i) {
+    public void addStat(@Nullable Stat stat, int i) {
         if (stat == null) {
             return;
         }
@@ -397,7 +402,7 @@ public class PlayerLocal extends Player {
     }
 
     @Override
-    public int getStat(Stat stat) {
+    public int getStat(@Nullable Stat stat) {
         return this.mc.statsCounter.readStat(stat);
     }
 
@@ -442,7 +447,7 @@ public class PlayerLocal extends Player {
     }
 
     public void syncPlacementMode() {
-        this.placementModeOverride = this.mc.gameSettings.placementMode.value;
+        this.placementModeOverride = GameSettings.PLACEMENT_MODE.value;
     }
 
     @Override
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ExceptionPopupElement.java b/game/client/src/main/java/net/minecraft/client/gui/ExceptionPopupElement.java
index 43f6dd3c9..153ae924e 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ExceptionPopupElement.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ExceptionPopupElement.java
@@ -4,11 +4,11 @@ import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.popup.PopupScreen;
 import net.minecraft.client.gui.popup.PopupBuilder;
 import net.minecraft.client.gui.popup.PopupCloseListener;
+import net.minecraft.client.render.OpenGLHelper;
 import net.minecraft.core.Global;
 import net.minecraft.core.net.command.TextFormatting;
 import org.jetbrains.annotations.NotNull;
 import org.lwjgl.Sys;
-import org.lwjgl.opengl.GL41;
 
 import java.text.SimpleDateFormat;
 import java.util.Date;
@@ -17,7 +17,6 @@ import java.util.Map;
 public class ExceptionPopupElement {
 
     public static PopupScreen create(Screen parent, Throwable e, Minecraft mc) {
-        int scale = Math.max(mc.resolution.getScale(), 1);
         StringBuilder s = new StringBuilder("Minecraft ran into an unexpected problem!\n\n");
         s.append("To prevent more problems, the current game has quit, but you can try to keep playing.\n\n");
         s.append("If you wish to report this, please copy this entire text and post it on the support portal at")
@@ -31,7 +30,7 @@ public class ExceptionPopupElement {
             s.append("Java: ").append(System.getProperty("java.version")).append(", ").append(System.getProperty("java.vendor")).append("\n");
             s.append("VM: ").append(System.getProperty("java.vm.name")).append(" (").append(System.getProperty("java.vm.info")).append("), ").append(System.getProperty("java.vm.vendor")).append("\n");
             s.append("LWJGL: ").append(Sys.getVersion()).append("\n");
-            s.append("OpenGL: ").append(GL41.glGetString(GL41.GL_RENDERER)).append(" version ").append(GL41.glGetString(GL41.GL_VERSION)).append(", ").append(GL41.glGetString(GL41.GL_VENDOR)).append("\n\n");
+            s.append("OpenGL: ").append(OpenGLHelper.renderer).append(" version ").append(OpenGLHelper.version).append(", ").append(OpenGLHelper.vendor).append("\n\n");
         } catch (Throwable throwable) {
             s.append("[failed to get system properties (").append(throwable).append(")]\n\n");
         }
@@ -43,15 +42,14 @@ public class ExceptionPopupElement {
         s.append(TextFormatting.WHITE);
 
 
-        return new PopupBuilder(parent, 860 / scale).withLabel("gui.exception.label.exception_occurred")
-            .withMessageBox("gui.exception.list", 400 / scale, s.toString(), (860 / scale) / mc.font.getFont().charWidth('m'))
+        return new PopupBuilder(parent, mc.resolution.getScaledWidthScreenCoords() - 60).withLabel("gui.exception.label.exception_occurred")
+            .withMessageBox("gui.exception.list", mc.resolution.getScaledHeightScreenCoords() - 120, s.toString(), (mc.resolution.getScaledWidthScreenCoords() - 60) / mc.font.getFont().charWidth('m'))
             .withButtonGroup("gui.exception.choice", new String[]{"gui.exception.button.back", "gui.exception.button.copy_error"}, new int[]{0, 1})
             .withOnCloseListener(new PopupListener(mc, s.toString().replaceAll("§[0-9a-f|klmnor]", "")))
             .build();
     }
 
     public static PopupScreen createFatal(Throwable e, Minecraft mc) {
-        int scale = Math.max(mc.resolution.getScale(), 1);
         StringBuilder s = new StringBuilder("Minecraft ran into an unexpected problem that it cannot recover from!\n\n");
         s.append("The current game has quit, please restart the game.\n\n");
         s.append("If you wish to report this, please copy this entire text and post it on the support portal at")
@@ -65,7 +63,7 @@ public class ExceptionPopupElement {
             s.append("Java: ").append(System.getProperty("java.version")).append(", ").append(System.getProperty("java.vendor")).append("\n");
             s.append("VM: ").append(System.getProperty("java.vm.name")).append(" (").append(System.getProperty("java.vm.info")).append("), ").append(System.getProperty("java.vm.vendor")).append("\n");
             s.append("LWJGL: ").append(Sys.getVersion()).append("\n");
-            s.append("OpenGL: ").append(GL41.glGetString(GL41.GL_RENDERER)).append(" version ").append(GL41.glGetString(GL41.GL_VERSION)).append(", ").append(GL41.glGetString(GL41.GL_VENDOR)).append("\n\n");
+            s.append("OpenGL: ").append(OpenGLHelper.renderer).append(" version ").append(OpenGLHelper.version).append(", ").append(OpenGLHelper.vendor).append("\n\n");
         } catch (Throwable throwable) {
             s.append("[failed to get system properties (").append(throwable).append(")]\n\n");
         }
@@ -78,8 +76,8 @@ public class ExceptionPopupElement {
 
         ScreenBlank screen = new ScreenBlank();
         mc.displayScreen(screen);
-        return new PopupBuilder(screen, 860 / scale).withLabel("gui.exception.label.fatal_error")
-            .withMessageBox("gui.exception.list", 400 / scale, s.toString(), (860 / scale) / mc.font.getFont().charWidth('m'))
+        return new PopupBuilder(screen, mc.resolution.getScaledWidthScreenCoords() - 60).withLabel("gui.exception.label.fatal_error")
+            .withMessageBox("gui.exception.list", mc.resolution.getScaledHeightScreenCoords() - 120, s.toString(), (mc.resolution.getScaledWidthScreenCoords() - 60) / mc.font.getFont().charWidth('m'))
             .withButtonGroup("gui.exception.choice", new String[]{"gui.exception.button.copy_error", "gui.exception.button.copy_error_and_quit"}, new int[]{0, 2}, new boolean[]{false, true})
             .withBackgroundColor(0xff402020, 0xff501010)
             .withOnCloseListener(new PopupListener(mc, s.toString().replaceAll("§[0-9a-f|klmnor]", "")))
@@ -87,7 +85,6 @@ public class ExceptionPopupElement {
     }
 
     public static PopupScreen createStartupError(Throwable e, Minecraft mc) {
-        int scale = Math.max(mc.resolution.getScale(), 1);
         StringBuilder s = new StringBuilder("An error has prevented Minecraft from starting up correctly!\n\n");
         s.append("The game cannot continue, please restart the game.\n\n");
         s.append("If you wish to report this, please copy this entire text and post it on the support portal at")
@@ -101,8 +98,7 @@ public class ExceptionPopupElement {
             s.append("Java: ").append(System.getProperty("java.version")).append(", ").append(System.getProperty("java.vendor")).append("\n");
             s.append("VM: ").append(System.getProperty("java.vm.name")).append(" (").append(System.getProperty("java.vm.info")).append("), ").append(System.getProperty("java.vm.vendor")).append("\n");
             s.append("LWJGL: ").append(Sys.getVersion()).append("\n");
-            //s1 = GL41.glGetString(GL41.GL_VENDOR);
-            s.append("OpenGL: ").append(GL41.glGetString(GL41.GL_RENDERER)).append(" version ").append(GL41.glGetString(GL41.GL_VERSION)).append(", ").append(GL41.glGetString(GL41.GL_VENDOR)).append("\n\n");
+            s.append("OpenGL: ").append(OpenGLHelper.renderer).append(" version ").append(OpenGLHelper.version).append(", ").append(OpenGLHelper.vendor).append("\n\n");
         } catch (Throwable throwable) {
             s.append("[failed to get system properties (").append(throwable).append(")]\n\n");
         }
@@ -115,8 +111,8 @@ public class ExceptionPopupElement {
 
         ScreenBlank screen = new ScreenBlank();
         mc.displayScreen(screen);
-        return new PopupBuilder(screen, 860 / scale).withLabel("gui.exception.label.startup_error")
-            .withMessageBox("gui.exception.list", 400 / scale, s.toString(), (860 / scale) / mc.font.getFont().charWidth('m'))
+        return new PopupBuilder(screen, mc.resolution.getScaledWidthScreenCoords() - 60).withLabel("gui.exception.label.startup_error")
+            .withMessageBox("gui.exception.list", mc.resolution.getScaledHeightScreenCoords() - 120, s.toString(), (mc.resolution.getScaledWidthScreenCoords() - 60) / mc.font.getFont().charWidth('m'))
             .withButtonGroup("gui.exception.choice", new String[]{"gui.exception.button.copy_error", "gui.exception.button.copy_error_and_quit"}, new int[]{0, 2}, new boolean[]{false, true})
             .withBackgroundColor(0xff402020, 0xff501010)
             .withOnCloseListener(new PopupListener(mc, s.toString().replaceAll("§[0-9a-f|klmnor]", "")))
diff --git a/game/client/src/main/java/net/minecraft/client/gui/HeldItemTooltipElement.java b/game/client/src/main/java/net/minecraft/client/gui/HeldItemTooltipElement.java
index 9f445687c..2f19fb116 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/HeldItemTooltipElement.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/HeldItemTooltipElement.java
@@ -1,6 +1,7 @@
 package net.minecraft.client.gui;
 
 import net.minecraft.client.Minecraft;
+import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.option.Option;
 import net.minecraft.client.render.renderer.BlendFactor;
 import net.minecraft.client.render.renderer.GLRenderer;
@@ -8,12 +9,11 @@ import net.minecraft.client.render.renderer.State;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.client.util.helper.Colors;
 import net.minecraft.core.util.helper.Time;
+import org.jetbrains.annotations.NotNull;
 
 public class HeldItemTooltipElement extends Gui {
 
-	private final Minecraft mc;
-	
-	private int lastItemID;
+    private int lastItemID;
 	private int lastSelectedItem;
 	
 	private String string;
@@ -25,12 +25,10 @@ public class HeldItemTooltipElement extends Gui {
 	private final double displayTime = 2.5;
 	private final double fadeTime = 0.5;
 	
-	public HeldItemTooltipElement(Minecraft mc) {
-		this.mc = mc;
-	}
+	public HeldItemTooltipElement() {}
 	
 	public void updateAndRender(Minecraft mc, int width, int height, int screenPadding) {
-		if(mc.gameSettings.heldItemTooltips.value) {
+		if(GameSettings.HELD_ITEM_TOOLTIPS.value) {
 			ItemStack item = mc.thePlayer.getCurrentEquippedItem();
 			
 			int id = getItemID(item);
@@ -49,7 +47,7 @@ public class HeldItemTooltipElement extends Gui {
 		render(mc, width, height, screenPadding);
 	}
 	public void updateAndRender(Minecraft mc, int x, int y) {
-		if(mc.gameSettings.heldItemTooltips.value) {
+		if(GameSettings.HELD_ITEM_TOOLTIPS.value) {
 			ItemStack item = mc.thePlayer.getCurrentEquippedItem();
 
 			int id = getItemID(item);
@@ -78,8 +76,8 @@ public class HeldItemTooltipElement extends Gui {
 		this.color = Colors.allChatColors[item.getDisplayColor()].getARGB();
 	}
 	
-	public void setOptionNameAndValueString(Option<?> option) {
-		setString(option.getDisplayStringName() + ": " + this.mc.gameSettings.getDisplayString(option));
+	public void setOptionNameAndValueString(@NotNull Option<?> option) {
+		setString(option.getDisplayStringName() + ": " + option.getDisplayString());
 	}
 	
 	public void setString(String string) {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/Screen.java b/game/client/src/main/java/net/minecraft/client/gui/Screen.java
index 0e9676970..1f9f69bf6 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/Screen.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/Screen.java
@@ -5,6 +5,7 @@ import java.util.List;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.input.controller.ControllerInput;
+import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.font.FontRenderer;
 import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.renderer.State;
@@ -131,7 +132,7 @@ public abstract class Screen extends Gui {
             }
         }
         while (Keyboard.next()) {
-            if (Keyboard.getEventKeyState() && this.mc.gameSettings.showFrameTimes.isTrue() && DebugRender.keyPressed(Keyboard.getEventKey())) {
+            if (Keyboard.getEventKeyState() && GameSettings.SHOW_FRAME_TIMES.isTrue() && DebugRender.keyPressed(Keyboard.getEventKey())) {
                 continue;
             }
             final int eventKey = Keyboard.getEventKey();
@@ -145,7 +146,7 @@ public abstract class Screen extends Gui {
                     this.mc.gameWindow.toggleFullscreen();
                     return;
                 }
-                if (!(this instanceof ScreenConsole) && eventKey == this.mc.gameSettings.keyShowConsole.getKeyCode() && this.mc.gameSettings.developerMode.isTrue() && !Keyboard.areRepeatEventsEnabled()) {
+                if (!(this instanceof ScreenConsole) && eventKey == GameSettings.KEY_SHOW_CONSOLE.getKeyCode() && GameSettings.DEVELOPER_MODE.isTrue() && !Keyboard.areRepeatEventsEnabled()) {
                     this.mc.displayScreen(new ScreenConsole(this));
                     return;
                 }
@@ -162,7 +163,7 @@ public abstract class Screen extends Gui {
 
     public void renderBackground() {
         if (this.mc.currentWorld != null) {
-            final int color = this.mc.gameSettings.guiBackgroundColor.value.getARGB();
+            final int color = GameSettings.GUI_BACKGROUND_COLOR.value.getARGB();
             this.drawGradientRect(0, 0, this.width, this.height, color, color);
         } else {
             this.renderTexturedBackground();
diff --git a/game/client/src/main/java/net/minecraft/client/gui/ScreenConsole.java b/game/client/src/main/java/net/minecraft/client/gui/ScreenConsole.java
index 92594d1fb..b8a039991 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/ScreenConsole.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/ScreenConsole.java
@@ -8,6 +8,7 @@ import net.minecraft.client.console.syntax.RendererFactory;
 import net.minecraft.client.gui.text.ITextField;
 import net.minecraft.client.gui.text.TextFieldEditor;
 import net.minecraft.client.console.shell.RuntimeExecutor;
+import net.minecraft.client.option.GameSettings;
 import net.minecraft.client.render.font.Fonts;
 import net.minecraft.client.render.window.CursorShape;
 import net.minecraft.core.net.command.TextFormatting;
@@ -463,7 +464,7 @@ public class ScreenConsole extends Screen {
 
     @Override
     public void keyPressed(char eventCharacter, int eventKey, int mx, int my) {
-        if (eventKey == this.mc.gameSettings.keyShowConsole.getKeyCode() || eventKey == Keyboard.KEY_ESCAPE) {
+        if (eventKey == GameSettings.KEY_SHOW_CONSOLE.getKeyCode() || eventKey == Keyboard.KEY_ESCAPE) {
             this.mc.displayScreen(this.parentScreen);
         } else {
             if (eventKey == Keyboard.KEY_RETURN) {
